
  <!DOCTYPE html>
  <html lang="en">
    <head>
      <meta charset="utf-8" />
      <meta name="vcs" content="git"/>
<meta name="vcs:default-branch" content="master"/>
<meta name="vcs:clone" content="https://github.com/fluhus/godoc-tricks.git"/>
<meta name="vcs:clone" content="git@github.com:fluhus/godoc-tricks.git"/>
<meta name="forge:summary" content="https://github.com/fluhus/godoc-tricks"/>
<meta name="forge:dir" content="https://github.com/fluhus/godoc-tricks/blob/{ref}/{path}"/>
<meta name="forge:file" content="https://github.com/fluhus/godoc-tricks/blob/{ref}/{path}"/>
<meta name="forge:rawfile" content="https://github.com/fluhus/godoc-tricks/raw/{ref}/{path}"/>
<meta name="forge:line" content="https://github.com/fluhus/godoc-tricks/blob/{ref}/{path}#L{line}"/>
<meta name="go-import" content="github.com/fluhus/godoc-tricks git https://github.com/fluhus/godoc-tricks.git"/>
<meta name="go-source" content="github.com/fluhus/godoc-tricks https://github.com/fluhus/godoc-tricks https://github.com/fluhus/godoc-tricks/blob/{commit}/{file} https://github.com/fluhus/godoc-tricks/blob/{commit}/{file}#L{line}"/>
<link href="/reseter.min.css" rel="stylesheet">
<link href="/style.css" rel="stylesheet">

      <meta name="viewport" content="width=device-width, initial-scale=1.0" />
      
        <title>godoctricks package - github.com/fluhus/godoc-tricks</title>
    </head>
    <body>
        <div class="module-nav sticky-header">
          <div>
            <a href="#top" title="Back to top"
              >github.com/fluhus/godoc-tricks <span>↑</span></a
            >
          </div>
          <nav><a
                href="#pkg-index"
                >Index</a
              >
            <span>|</span>&nbsp;<a
                href="#pkg-examples"
                >Examples</a
              >
            <span>|</span>&nbsp;<a
                href="#pkg-note-bug"
                >Bugs</a
              >
            <span>|</span>&nbsp;<a
                href="#pkg-files"
                >Files</a
              >
            <span>|</span>&nbsp;<a
                href="#pkg-forge"
                >Forge</a
              >
            </nav>
        </div>
      
  <h1 id="pkg-overview">godoctricks package</h1>

    <p><code>import godoctricks "github.com/fluhus/godoc-tricks"</code></p>
    <p>Package godoctricks is a tutorial on the features of GoDoc.
It is meant to help eveyone make the most out of this feature of Go.
<p>Notice that this doc is written in godoc itself as package documentation.
The defined types are just for making the table of contents at the
head of the page; they have no meanings as actual types.
<p>If you have any suggestion or comment, please feel free to <a href="https://github.com/fluhus/godoc-tricks/issues">open an issue</a>.
<p>By Amit Lavon.
<h2 id="hdr-Update__Go_1_19_is_here_">Update: Go 1.19 is here!</h2>
<p>The new version introduces a few additions to what the godoc tool can
recognize. You can see them below at <a href="#Links">Links</a>, <a href="#Headings">Headings</a> and <a href="#Lists">Lists</a>.
The official documentation is at: <a href="https://go.dev/doc/comment">https://go.dev/doc/comment</a>

    
  
      <details>
        <summary id="example-">
          Example
          
          <a href="#example-" class="permalink">¶</a>
        </summary>
        <p>This function is named Example(), which is a package level test
function.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L9" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;)
</pre>
          </div>
        
      </details>
    
      <details>
        <summary id="example-_other">
          Example
          (other)
          <a href="#example-_other" class="permalink">¶</a>
        </summary>
        <p>This function is named Example_other(), which is a package level test
function and has the label &quot;other&quot;.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L15" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;)
</pre>
          </div>
        
      </details>
    
      <details>
        <summary id="example-_wholeFilePackage">
          Example
          (wholeFilePackage)
          <a href="#example-_wholeFilePackage" class="permalink">¶</a>
        </summary>
        <p>A whole file example is a file that ends in `_test.go` and contains exactly one
example function, no test or benchmark functions, and at least one other
package-level declaration.

        <pre>package main

import &#34;fmt&#34;

var message = &#34;Hello&#34;

// A whole file example is a file that ends in `_test.go` and contains exactly one
// example function, no test or benchmark functions, and at least one other
// package-level declaration.
func main() {
	fmt.Println(message)
}
</pre>
            <p>Output:</p>
            <pre>Hello
</pre>
      </details>
    
  


    <h2 id="pkg-index">Index <a href="#pkg-index" class="permalink">¶</a></h2>

      <ul>
        
        
        
          <li><a href="#FuncExampleWithoutType">func FuncExampleWithoutType() int</a></li>
        
        
          <li>
            <a href="#Bugs">type Bugs</a>
            
          </li>
        
          <li>
            <a href="#CodeBlocks">type CodeBlocks</a>
            
          </li>
        
          <li>
            <a href="#Enums">type Enums</a>
            
          </li>
        
          <li>
            <a href="#Examples">type Examples</a>
            
              <ul>
                
                  <li><a href="#NewExamples">func NewExamples() Examples</a></li>
                
                
                  <li>
                    <a href="#Examples.ExampleMethod"
                      >func (e Examples) ExampleMethod() int</a
                    >
                  </li>
                
              </ul>
            
          </li>
        
          <li>
            <a href="#Github">type Github</a>
            
          </li>
        
          <li>
            <a href="#Headings">type Headings</a>
            
          </li>
        
          <li>
            <a href="#Interface">type Interface</a>
            
          </li>
        
          <li>
            <a href="#Links">type Links</a>
            
          </li>
        
          <li>
            <a href="#Lists">type Lists</a>
            
          </li>
        
          <li>
            <a href="#LocalServer">type LocalServer</a>
            
          </li>
        
          <li>
            <a href="#Methods">type Methods</a>
            
              <ul>
                
                  <li><a href="#NewMethods">func NewMethods() *Methods</a></li>
                
                
                  <li>
                    <a href="#Methods.Foo"
                      >func (Methods) Foo()</a
                    >
                  </li>
                
                  <li>
                    <a href="#Methods.Foo2"
                      >func (*Methods) Foo2()</a
                    >
                  </li>
                
              </ul>
            
          </li>
        
          <li>
            <a href="#Paragraphs">type Paragraphs</a>
            
          </li>
        
          <li>
            <a href="#Struct">type Struct</a>
            
          </li>
        
      </ul>
    
      <h2 id="pkg-examples">
        Examples
        <a href="#pkg-examples" class="permalink">¶</a>
      </h2>

      <ul>
        
          <li>
            <a href="#example-"
              >Package </a
            >
          </li>
        
          <li>
            <a href="#example-_other"
              >Package (other)</a
            >
          </li>
        
          <li>
            <a href="#example-_wholeFilePackage"
              >Package (wholeFilePackage)</a
            >
          </li>
        
        
          
            <li>
              <a href="#example-FuncExampleWithoutType"
                >FuncExampleWithoutType </a
              >
            </li>
          
        
        
          
          
          
        
          
          
          
        
          
          
          
        
          
            <li>
              <a href="#example-Examples"
                >Examples </a
              >
            </li>
          
            <li>
              <a href="#example-Examples_other"
                >Examples (other)</a
              >
            </li>
          
            <li>
              <a href="#example-Examples_output"
                >Examples (output)</a
              >
            </li>
          
            <li>
              <a href="#example-Examples_wholeFileType"
                >Examples (wholeFileType)</a
              >
            </li>
          
          
            
              <li>
                <a href="#example-NewExamples"
                  >NewExamples </a
                >
              </li>
            
          
          
            
              <li>
                <a href="#example-Examples_ExampleMethod"
                  >Examples.ExampleMethod
                  </a
                >
              </li>
            
          
        
          
          
          
        
          
          
          
        
          
          
          
        
          
          
          
        
          
          
          
        
          
          
          
        
          
          
            
          
          
            
          
            
          
        
          
          
          
        
          
          
          
        
      </ul>
    

    

    

    
      <h2 id="FuncExampleWithoutType" data-kind="function">
        func
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L145" rel="noopener nofollow" title="View Source">FuncExampleWithoutType</a>

        <a href="#FuncExampleWithoutType" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L145" rel="noopener nofollow" title="View Source">❖</a>

        <pre>func FuncExampleWithoutType() <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>FuncExampleWithoutType is a func with an associated example (but not associated type).
See <a href="#Examples">Examples</a> regarding the details.

      
  
      <details>
        <summary id="example-FuncExampleWithoutType">
          Example
          
          <a href="#example-FuncExampleWithoutType" class="permalink">¶</a>
        </summary>
        <p>This function is named ExampleFuncExampleWithoutType(), this way godoc knows to associate
it with the FuncExampleWithoutType func.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L52" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;, FuncExampleWithoutType())
</pre>
          </div>
        
      </details>
    
  

    

    
      <h2 id="Bugs" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L253" rel="noopener nofollow" title="View Source">Bugs</a>

        <a href="#Bugs" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L253" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Bugs <a href="https://pkg.go.dev/go/doc">doc</a>.<a href="https://pkg.go.dev/go/doc#Note">Note</a></pre>
      </div>
      <p>You can use words other than &quot;BUG&quot;, like &quot;TODO&quot;. General syntax:
MARKER(uid), with MARKER at least 2 chars (all caps) and uid at least 1 char.
<p>By default, only BUG notes are shown. If you run a godoc server locally, you
can control that with the -notes argument. For example, -notes=&quot;BUG|TODO&quot;.

      
      
      
  

      
      
    
      <h2 id="CodeBlocks" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L160" rel="noopener nofollow" title="View Source">CodeBlocks</a>

        <a href="#CodeBlocks" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L160" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type CodeBlocks <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>You can embed blocks of code in your godoc, such as this:
<pre>fmt.Println(&quot;Hello&quot;)
</pre>
<p>To do that, simply add an extra indent to your comment&apos;s text.
<p>For example, the code of the first lines of this section looks like this:
<pre>// You can embed blocks of code in your godoc, such as this:
//  fmt.Println(&quot;Hello&quot;)
// To do that, simply add an extra indent to your comment&apos;s text.
</pre>

      
      
      
  

      
      
    
      <h2 id="Enums" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L98" rel="noopener nofollow" title="View Source">Enums</a>

        <a href="#Enums" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L98" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Enums <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>While there are no built in enums in go, you can use types and constants
to make enum lookalikes (documentation-wise). Take this Enums type for
example; if you have a const/var clause where all the values are of the same
type, it will be attached to that type&apos;s godoc. See below.

      
        <div data-kind="constant" class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L100" rel="noopener nofollow" title="View Source">❖</a>

          <pre>const (
	<span id="A">A</span> <a href="#Enums">Enums</a> = <a href="https://pkg.go.dev/builtin#iota">iota</a>
	<span id="B">B</span>
)</pre>
        </div>
        
      
      
      
  

      
      
    
      <h2 id="Examples" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L131" rel="noopener nofollow" title="View Source">Examples</a>

        <a href="#Examples" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L131" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Examples <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>You can place usage examples in your godoc.
<p>Examples should be placed in a file with a _test suffix. For example, the
examples in this guide are in a file called doc_test.go .
<p>The example functions should be called Example() for
package examples, ExampleTypename() for a specific type or
ExampleFuncname() for a specific function, ExampleTypename_Methodname() for
a method on a specific type.
<p>For multiple examples for the same entity (like same function), you can add
a suffix starting with a lowercase like ExampleFoo_suffix1, ExampleFoo_suffix2.
<p>You can document an example&apos;s output, by adding an output comment at its end.
The output comment must begin with &quot;Output:&quot;, as shown below:
<pre>func ExampleExamples_output() {
    fmt.Println(&quot;Hello&quot;)
    // Output: Hello
}
</pre>
<p>Notice that the tricks brought here (headings, code blocks, links etc.)
don&apos;t work in example documentation.
<p>For full documentation of examples, see:
<a href="http://golang.org/pkg/testing/">http://golang.org/pkg/testing/</a>

      
      
      
  
      <details>
        <summary id="example-Examples">
          Example
          
          <a href="#example-Examples" class="permalink">¶</a>
        </summary>
        <p>This function is named ExampleExamples(), this way godoc knows to associate
it with the Examples type.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L21" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;)
</pre>
          </div>
        
      </details>
    
      <details>
        <summary id="example-Examples_other">
          Example
          (other)
          <a href="#example-Examples_other" class="permalink">¶</a>
        </summary>
        <p>This function is named ExampleExamples_other(), it is associated with
Examples type and has the label &quot;Other&quot;.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L27" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;)
</pre>
          </div>
        
      </details>
    
      <details>
        <summary id="example-Examples_output">
          Example
          (output)
          <a href="#example-Examples_output" class="permalink">¶</a>
        </summary>
        <p>This is how godoc parsed ExampleExamples_output() that was shown above.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L32" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;)
// Output: Hello
</pre>
          </div>
        
      </details>
    
      <details>
        <summary id="example-Examples_wholeFileType">
          Example
          (wholeFileType)
          <a href="#example-Examples_wholeFileType" class="permalink">¶</a>
        </summary>
        <p>A whole file example can also be attached to a given type (Examples here)
with appropriate naming.
<p>A whole file example is a file that ends in `_test.go` and contains exactly one
example function, no test or benchmark functions, and at least one other
package-level declaration.

        <pre>package main

import &#34;fmt&#34;

var messageExample = &#34;Hello&#34;

// A whole file example can also be attached to a given type (Examples here)
// with appropriate naming.
//
// A whole file example is a file that ends in `_test.go` and contains exactly one
// example function, no test or benchmark functions, and at least one other
// package-level declaration.
func main() {
	fmt.Println(messageExample)
}
</pre>
      </details>
    
  

      
        <h3 id="NewExamples" data-kind="function">
          func
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L134" rel="noopener nofollow" title="View Source">NewExamples</a>

          <a href="#NewExamples" class="permalink">¶</a>
        </h3>
        <div class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L134" rel="noopener nofollow" title="View Source">❖</a>

          <pre>func NewExamples() <a href="#Examples">Examples</a></pre>
        </div>
        <p>NewExamples is a func with an associated example. See <a href="#Examples">Examples</a> regarding the details.

        
  
      <details>
        <summary id="example-NewExamples">
          Example
          
          <a href="#example-NewExamples" class="permalink">¶</a>
        </summary>
        <p>This function is named ExampleNewExamples(), this way godoc knows to associate
it with the NewExamples func.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L39" rel="noopener nofollow" title="View Source">❖</a>

            <pre>fmt.Println(&#34;Hello&#34;, NewExamples())
</pre>
          </div>
        
      </details>
    
  

      
      
        <h3 id="Examples.ExampleMethod" data-kind="method">
          func (Examples)
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L139" rel="noopener nofollow" title="View Source">ExampleMethod</a>

          <a href="#Examples.ExampleMethod" class="permalink">¶</a>
        </h3>
        <div class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L139" rel="noopener nofollow" title="View Source">❖</a>

          <pre>func (e <a href="#Examples">Examples</a>) ExampleMethod() <a href="https://pkg.go.dev/builtin#int">int</a></pre>
        </div>
        <p>ExampleMethod is a method with an associated example. See <a href="#Examples">Examples</a> regarding the details.

        
  
      <details>
        <summary id="example-Examples_ExampleMethod">
          Example
          
          <a href="#example-Examples_ExampleMethod" class="permalink">¶</a>
        </summary>
        <p>This function is named ExampleExamples_ExampleMethod(), this way godoc knows to associate
it with the ExampleMethod method of the Examples type.

        <div class="corner-forge-link">
            <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc_test.go#L45" rel="noopener nofollow" title="View Source">❖</a>

            <pre>e := Examples(42)
fmt.Println(&#34;Hello&#34;, e.ExampleMethod())
</pre>
          </div>
        
      </details>
    
  

      
    
      <h2 id="Github" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L43" rel="noopener nofollow" title="View Source">Github</a>

        <a href="#Github" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L43" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Github <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>Go code that you upload to public repositories on github appears
automatically on the godoc website. Just like this tutorial! Just check in
your code and watch as it appears. Use this page&apos;s URL as reference.
<p>The godoc page gets updated once you make a new release.

      
      
      
  

      
      
    
      <h2 id="Headings" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L92" rel="noopener nofollow" title="View Source">Headings</a>

        <a href="#Headings" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L92" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Headings <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>You can make headings in your godoc.
An explicit heading line starts with a &apos;#&apos; and is separated from the previous
and next paragraphs with empty comment lines.
An implicit heading is the same without the &apos;#&apos; (`go fmt` will automatically add a leading #).
It needs to begin with a capital letter and not end with punctuation.
<p>See the full documentation here: <a href="https://go.dev/doc/comment#headings">https://go.dev/doc/comment#headings</a>
<p>For example, this code:
<pre>// # Explicit Heading
//
// Yada yada.
//
// Implicit Heading
//
// Yolo yolo.
</pre>
<p>Results in:
<h3 id="hdr-Explicit_Heading">Explicit Heading</h3>
<p>Yada yada.
<h3 id="hdr-Implicit_Heading">Implicit Heading</h3>
<p>Yolo yolo.

      
      
      
  

      
      
    
      <h2 id="Interface" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L282" rel="noopener nofollow" title="View Source">Interface</a>

        <a href="#Interface" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L282" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Interface interface {
	Method()
}</pre>
      </div>
      <p>Interface are rendered like Struct:
<ul>
<li>exported methods are shown (with comments)
<li>unexported methods are hidden
</ul>

      
      
      
  

      
      
    
      <h2 id="Links" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L201" rel="noopener nofollow" title="View Source">Links</a>

        <a href="#Links" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L201" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Links <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>There are several ways to embed links in godoc.
<h3 id="hdr-Regular_URLs">Regular URLs</h3>
<p>Web addresses will automatically generate links in the HTML output,
like this: <a href="http://www.golang.org">http://www.golang.org</a>
<h3 id="hdr-Documentation_Links">Documentation Links</h3>
<p>You can link to identifiers in the documentation with square brackets.
<ul>
<li>[Name] or [Name.Name] for a member of the current package
<li>[pkg], [pkg.Name] or [pks.Name.Name] for a member of an imported package
<li><a href="https://pkg.go.dev/import/path/pkg">import/path/pkg</a>, <a href="https://pkg.go.dev/import/path/pkg#Name">import/path/pkg.Name</a> or <a href="https://pkg.go.dev/import/path/pkg#Name.Name">import/path/pkg.Name.Name</a>
for a member of a non-imported package
</ul>
<h3 id="hdr-Markdown_Style_Links">Markdown-Style Links</h3>
<p>Lines of the form &quot;[something]: URL&quot; turn the occurrences of [something]
into links to that URL with the text &quot;something&quot;.
Lines of that form need to be separated from regular text with empty doc
lines.
<p>For example:
<pre>You can search for Go [online].
See our [Links] section or [Methods.Foo].
Go to the imported [doc] package or the [doc.Note] struct.
Visit us under [github.com/fluhus/godoc-tricks.Links]

[online]: https://duckduckgo.com/?q=golang
</pre>
<p>Results in:
<p>You can search for Go <a href="https://duckduckgo.com/?q=golang">online</a>.
See our <a href="#Links">Links</a> section or <a href="#Methods.Foo">Methods.Foo</a>.
Go to the imported <a href="https://pkg.go.dev/go/doc">doc</a> package or the <a href="https://pkg.go.dev/go/doc#Note">doc.Note</a> struct.
Visit us under <a href="/fluhus/godoc-tricks#Links">github.com/fluhus/godoc-tricks.Links</a>.

      
      
      
  

      
      
    
      <h2 id="Lists" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L277" rel="noopener nofollow" title="View Source">Lists</a>

        <a href="#Lists" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L277" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Lists <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>Indented lines that start with dashes, stars, or pluses (or
<a href="https://go.dev/doc/comment#lists">other unicode characters</a>) create lists.
<p>For example:
<pre>This is my list
 - item 1
 - item 2
</pre>
<p>Results in:
<p>This is my list
<ul>
<li>item 1
<li>item 2
</ul>

      
      
      
  

      
      
    
      <h2 id="LocalServer" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L36" rel="noopener nofollow" title="View Source">LocalServer</a>

        <a href="#LocalServer" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L36" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type LocalServer <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>You can run a local godoc server. This is helpful for previewing
documentation, or for cases where you don&apos;t have a stable internet
connection.
<pre>go run golang.org/x/tools/cmd/godoc@latest
</pre>
<p>godoc will listen on <a href="http://localhost:6060">http://localhost:6060</a>.
Run with -h to see how you can control the port number and other options.

      
      
      
  

      
      
    
      <h2 id="Methods" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L205" rel="noopener nofollow" title="View Source">Methods</a>

        <a href="#Methods" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L205" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Methods <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>Methods are functions with receivers. Godoc associates methods with their
receivers and attaches their documentation. See below.

      
      
      
  

      
        <h3 id="NewMethods" data-kind="function">
          func
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L216" rel="noopener nofollow" title="View Source">NewMethods</a>

          <a href="#NewMethods" class="permalink">¶</a>
        </h3>
        <div class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L216" rel="noopener nofollow" title="View Source">❖</a>

          <pre>func NewMethods() *<a href="#Methods">Methods</a></pre>
        </div>
        <p>Functions that construct an instance of a type (or a pointer to it) are
associated with the returned type.

        
  

      
      
        <h3 id="Methods.Foo" data-kind="method">
          func (Methods)
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L209" rel="noopener nofollow" title="View Source">Foo</a>

          <a href="#Methods.Foo" class="permalink">¶</a>
        </h3>
        <div class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L209" rel="noopener nofollow" title="View Source">❖</a>

          <pre>func (<a href="#Methods">Methods</a>) Foo()</pre>
        </div>
        <p>Methods are attached to their receiver type in the godoc, regardless of
their physical location in the code.

        
  

      
        <h3 id="Methods.Foo2" data-kind="method">
          func (*Methods)
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L212" rel="noopener nofollow" title="View Source">Foo2</a>

          <a href="#Methods.Foo2" class="permalink">¶</a>
        </h3>
        <div class="corner-forge-link">
          <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L212" rel="noopener nofollow" title="View Source">❖</a>

          <pre>func (*<a href="#Methods">Methods</a>) Foo2()</pre>
        </div>
        <p>Pointer receivers are also associated in the same way.

        
  

      
    
      <h2 id="Paragraphs" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L63" rel="noopener nofollow" title="View Source">Paragraphs</a>

        <a href="#Paragraphs" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L63" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Paragraphs <a href="https://pkg.go.dev/builtin#int">int</a></pre>
      </div>
      <p>To start a new paragraph, add an empty line in the comment between the 2
paragraphs.
<p>For example:
<pre>// Paragraph 1.
// Still paragraph 1.
//
// Paragraph 2.
// Still Paragraph 2.
</pre>
<p>Results in:
<p>Paragraph 1.
Still paragraph 1.
<p>Paragraph 2.
Still Paragraph 2.

      
      
      
  

      
      
    
      <h2 id="Struct" data-kind="type">
        type
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L232" rel="noopener nofollow" title="View Source">Struct</a>

        <a href="#Struct" class="permalink">¶</a>
      </h2>
      <div class="corner-forge-link">
        <a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L232" rel="noopener nofollow" title="View Source">❖</a>

        <pre>type Struct struct {
	<span class="comment">// ExportedField can have a comment on the line above.</span>
	ExportedField       <a href="https://pkg.go.dev/builtin#int">int</a>
	OtherExportedField  <a href="#Links">Links</a> <span class="comment">// or on the same line</span>
	FieldWithoutComment struct{}
	<span class="comment">// contains filtered or unexported fields</span>
}</pre>
      </div>
      <p>Struct will be shown with their exported fields. Unexported fields
will be hidden under a comment &quot;contains filtered or unexported fields&quot;.
For instance the following struct
<pre>type Struct struct {
	// ExportedField can have a comment on the line above.
	ExportedField       int
	OtherExportedField  Links // or on the same line
	FieldWithoutComment struct{}

	hidden int // unexported fields (and their comments) will not be shown in the documentation
}
</pre>
<p>will be rendered as:

      
      
      
  

      
      
    

    
      
        <h2 id="pkg-note-bug">
          Bugs <a href="#pkg-note-bug" class="permalink">¶</a>
        </h2>
        
          <p><a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go#L255" rel="noopener nofollow" title="View Source">⚠</a>
 This is an example bug.
See the [Bugs] section.
</p>
        
      
    

    
      <h2 id="pkg-files">
        Source Files
        <a href="#pkg-files" class="permalink">¶</a>
      </h2>
      <p><a href="https://github.com/fluhus/godoc-tricks/blob/master/doc.go" rel="noopener nofollow" title="View Source">doc.go</a>
</p>
    
  

  

  
      <h2 id="pkg-forge">
        Forge <a class="permalink" href="#pkg-forge">&para;</a>
      </h2>
        <p><a href="https://github.com/fluhus/godoc-tricks" rel="noopener nofollow">https://github.com/fluhus/godoc-tricks</a></p>

      
        <code>git clone</code>
        <pre>https://github.com/fluhus/godoc-tricks.git
git@github.com:fluhus/godoc-tricks.git
</pre
        >
        <div class="module-nav footer">
          <div>
            <span>github.com/fluhus/godoc-tricks</span>
          </div>
          <code>master</code>
        </div>
        <footer>
          <nav>
            Generated with
            <a href="https://code.pfad.fr/vanitydoc/">vanitydoc (devel)</a> &middot;
            <a href="https://go.dev">Go Language</a>
          </nav>
        </footer>
    </body>
  </html>
